window.__DOCS_SEARCH__ = [[{"l":"Welcome","p":["Welcome to the .NET Reactor Help file, which fully documents the use of .NET Reactor. Please study this document carefully, as it will answer many of your pre-purchase and usage questions."]}],[{"i":"what-is-net-reactor","l":"What is .NET Reactor?","p":[".NET Reactor is a powerful code protection and software licensing system for software written for the .NET Framework, and supports all languages that generate .NET assemblies. Its' main features are :","Anti Debugging","Anti Tampering","By number of uses (i.e. software as a service)","By time period (i.e. rent your software)","Code Virtualization","Control Flow Obfuscation","Create .NET Core/5.0/6.0 single file application bundles","Create trial versions of your software","Dependency Merging","Deployment","Easily turn your trial version into a fully licensed version","Extend licensing functions with bespoke extensions.","Hide Method Calls (dynamic proxy)","Integrate license checking into your assembly and extend licensing functionality","Intellectual property protection","License your software","Limit by number of uses","Limit to use for no more than a set number of minutes each invocation","Limit trial version functionality","Limit use to a fixed number of days after installation","Native Code generation","NecroBit Protection","Obfuscation","Permanently (nonexpiring license)","Powerful licensing system","Protects full applications and libraries (DLLs)","Resource Encryption and Compression","Set an expiration date","Software development kit","String Encryption"]},{"i":"why-you-need-to-protect-your-intellectual-property","l":"Why you need to protect your intellectual property.","p":["When you compile a program written for the Microsoft .NET framework, the program you provide to your users is not compiled into a native executable program, but instead is translated into something called the Common Intermediate Language instructions (CIL). CIL is halfway between source code and native code and is interpreted by the .NET framework when your program is run, rather than executed directly as machine code. Because of this, the source code of your application or library can be easily reproduced. Tools such as .NET Reflector ( link) can reproduce source code from compiled .NET assemblies in seconds and in the .NET language of your choice! Commercial software distributed to end users without some form of protection is wide open to piracy and intellectual property theft.","The traditional solution to intellectual property protection in .NET is to use 'obfuscation'. Indeed Microsoft makes an obfuscation utility available to Visual Studio users."]},{"i":"so-why-is-obfuscation-not-enough","l":"So why is obfuscation not enough?","p":["Obfuscation is the process of making your source code more difficult (but not impossible) for humans to understand. Obfuscation works by replacing the meaningful names you assign to classes, methods, properties and variables with meaningless ones. For example, it may replace a variable name of \"counter\" with \"A4DF3CV89G\" - to humans, these obfuscated names are confusing and difficult to remember but have no effect on the NET Framework interpreter. Note that obfuscation does nothing to the source code within your methods, so it is not protected at all by obfuscation. .NET Reactor does everything an obfuscator does but then wraps your intellectual property in several more layers of protection, denying access to your source code to even those who are determined to steal your hard work."]},{"l":"Industry Leading .NET Reactor Source Protection","p":[".NET Reactor prevents decompilation by a variety of methods which convert your .NET assemblies into processes which no existing tool can decompile ( and which are also very likely to prevent decompilation by any future tool). .NET Reactor builds a native code wall between potential hackers and your .NET assemblies by producing a file which cannot be understood directly as CIL. Because the CIL in your assembly is emitted intact only at run time or design time (in a form in which the source is completely inaccessible), no tool can decompile .NET Reactor protected assemblies.","The native code wall created by .NET Reactor between the hacker and your source includes industry-leading NecroBit technology is exclusive to .NET Reactor. These technologies make the reconstruction of your source code more difficult by so many orders of magnitude that NecroBit is by far the most effective protection you can use for .NET assemblies.","In addition to industry-leading intellectual property protection, .NET Reactor provides powerful options for securing your revenue stream by enforcing licensing terms with a wide variety of trial versions and full version locks.","NET Reactor offers you simple and reliable ways to:","Secure your .NET applications and .NET libraries","Replace CIL code with native code","Perform additional layers of protection, including obfuscation","Merge assemblies, and","Protect your revenue by enforcing trial version restrictions and full version licensing terms.","The protection mechanism is so simple you can download and install .NET Reactor, and produce your first truly protected .NET assembly in minutes, without any changes to your source code.","Supported Platforms : Windows 98, ME, NT, 2000, XP, Vista, 7, 8/8.1, 10, 11, Server 2003 - 2019","Supported Platforms (Mono) : Linux - SUSE, Novell, Red Hat, Mac - OS X, Solaris, BSD - OpenBSD, FreeBSD, NetBSD","Supported Platforms (Xamarin): Android, Apple iOS"]},{"l":"About this online help","p":["If you have any questions not answered by this help file, require additional information to complete your evaluation or have any suggestions for improving this help file, please get in touch with us, we will be very happy to help."]}],[{"l":"Features","p":[".NET Reactor can compress applications and embedded files up to 50-75%.",".NET Reactor can improve protection and assembly size by compressing and encrypting your managed resources. At runtime, when required the resources are automatically decompressed and decrypted.",".NET Reactor can merge or embed multiple .NET files into one executable(.exe) or library(.dll).",".NET Reactor is a mature product. It protects your software in a strong and reliable way without breaking the functionality of referenced 3rd party libraries.",".NET Reactor is able to generate a native x86 EXE file stub for your application. This way it is not possible to directly open your protected application in a decompiler. The decompiler recognizes your protected application as a native EXE file.",".NET Reactor is priced to make ownership affordable.",".NET Reactor offers full protection support for your ASP.NET / ASP.NET Core Applications and Libraries.",".NET Reactor offers various features to protect your software. Its' key features are :",".NET Reactor supports 32-bit and 64-bit Assemblies.",".NET Reactor supports all types of managed assemblies (C#, VB.NET, Managed C++, ASP.NET, Delphi.NET, J#...).","All features support command line invocation and event-driven invocation by Visual Studio Build Events. .NET Reactor produces the finished product in the same way you do.","An intuitive, easy-to-operate GUI provides quick, comfortable operation.","app command library Application, Library, and Windows Service","Automate compile-time protection using the .NET Reactor Visual Studio Add-in.","Code Virtualization converts your code into a set of randomized instructions which are interpreted at runtime by a virtual machine. As other tools can't interpret the new instructions, the original code can't be reconstructed.","Control Flow Obfuscation converts the code inside your methods into spaghetti code, which, whilst retaining the function of the code, makes it extremely difficult for human eyes and decompilers to follow the program logic. Decompilers cannot decompile the spaghetti code back to your original source code.","Create .NET Core single file application bundles without increasing the size of your application.","Declarative Obfuscation support allows you to directly define which types and members should be excluded from obfuscation. This can be done by using the custom attribute System.Reflection.ObfuscationAttribute in your source code. .NET Reactor automatically detects the attribute and excludes the corresponding types and members from obfuscation.","Description","Further tools and features include a Command-line Arguments Generator, Stack Trace Deobfuscator, Multi Assembly Protection, Strong Name Support, and even Digital Certificate Support.","Hide calls to external and/or internal methods. Method calls are redirected through delegates which are dynamically built at runtime.","img","img 64-bit Support","img Anti Debug","img Anti ILDASM / Anti Decompiler","img Azure DevOps","img Code Virtualization","img Command Line Support","img Compression","img Control Flow Obfuscation","img Declarative Obfuscation","img Fairly priced","img Full Language Support","img Further Tools / Features","img Hide Method Calls","img img img img img img","img Intuitive GUI","img Merging/Embedding","img Native EXE File","img NecroBit IL Code Protection","img Obfuscation","img Powerful Licensing System","img Pre-JIT Methods","img Resource Encryption and Compression","img String Encryption","img Strong Name Removal Protection","img Third Party Support","img Trust","img Visual Studio Add-in","img.NET Core Single File Deployment","In addition to source protection, .NET Reactor provides thorough class and member obfuscation complemented by different exclusion schemes, use of non-printable characters in obfuscated names, and even incremental obfuscation, which always generates the same obfuscation strings for type and member names.","In combination with the Native EXE File feature and NecroBit, .NET Reactor is able to convert managed methods into REAL x86 native code. Only methods which don't affect the runtime and platform behavior (mostly small methods like property getters/setters...) are converted into native code. By nature this feature has built-in protection against assembly modification.","Key Features","NecroBit is a powerful protection technology which stops decompilation. NecroBit replaces the CIL code within methods with encrypted code. This way it is not possible to decompile/reverse engineer your method source code.","NET Reactor supports all .NET Framework implementations, including .NET Core, .NET 5.0/6.0, Xamarin (Forms) and Mono:- .NET 5.0+- .NET Framework 1.1/2.0/3.0/3.5/4.x- .NET Core 1.0-3.x- .NET Standard 1.0-2.x- .NET Portable- .NET CF 1.1/2.0/3.5- Universal Windows- Xamarin Android, iOS, Mac- Mono 1.x/2.x- WinRT/Metro- Unity 3D- Windows Phone 7/8/10- Silverlight 2.0/3.0/4.0/5.0","No tool can disassemble/decompile .NET Reactor protected code. ILDASM (the Microsoft Intermediate Language disassembler) will report that it cannot interpret .NET Reactor protected assemblies.","Powerful and flexible licensing features to allow you to enforce your license conditions and protect your revenue stream by using hardware and software locks. The license manager can build trial or permanent licenses in a matter of seconds. A fully documented software development kit (SDK), complete with examples, allows you to call the licensing system directly from your code, allowing you to create custom extensions to the licensing system.","Seamless integration in Azure DevOps with .NET Reactor DevOps pipeline tasks.","String encryption makes it difficult for a hacker to understand your code and to attempt a code patch of your assembly, as he will be unable to identify the text of messages or other useful strings, making it much more difficult to identify where to patch your code. This feature has a built-in protection against assembly manipulation.","Strong Name Removal Protection prevents your protected assembly from being tampered with by hacker tools as they cannot correctly resign the assembly with a different strong name.","This feature enables anti-debugger detections inside the protected assembly. In case a debugger is attached, the current process will be terminated.","We trust our product. .NET Reactor is protected by itself.","Whatever your .NET product, .NET Reactor protects it. Windows: Windows Forms Applications & Libraries, WPF Applications & Libraries, Console Applications, Windows Services, Control & Class Libraries, Universal Windows Assemblies, WinRT/Metro Applications & Libraries Web: ASP.NET/ ASP.NET Core Applications & Libraries, Blazor, ASP.NET Services, WCF Services, Sharepoint WebParts Silverlight: Silverlight Applications & Libraries Smart Device: Xamarin Android, Xamarin iOS, Windows Phone, Compact Framework and PCL Assemblies Others:.NET 5.0+, NET Core and .NET Standard Assemblies, SQL Server CLR Assemblies, Mono Applications & Libraries, Unity Assemblies"]},{"l":"compatibility","p":["Our products are compatible with all .NET languages and support all Operating Systems where .NET Framework or Mono can be installed.","Supported Languages","C#, VB.NET, C++.NET, Delphi.NET, J#, F#, MSIL and more...","Supported Platforms","Windows 98, ME, NT, 2000, XP, Vista, 7, 8/8.1, 10, 11, Server 2003 - 2019","Supported Platforms .NET Core/5+","Android, iOS, Mac, Linux","Supported Platforms (Mono)","Max - OS X, Linux - SUSE, Novell, Red Hat, Debian..., Solaris, BSD - OpenBSD, FreeBSD, NetBSD"]}],[{"l":"System Requirements","p":["Development systems must meet the following minimum requirements:","IBM compatible PC with Pentium class microprocessor.","Windows 2000/2003/XP with 512 MB RAM, Windows 2008/Vista/7/8/8.1/10/11 with 2 GB RAM.","Administrative access is required to install to Windows NT/2000/XP/Vista or Windows 7/8/8.1/10/11.",".NET Framework 4.0 or higher."]}],[{"l":"Overview","p":["Main Window","The .NET Reactor UI is comprised of a menu system, Tasks Panel, Details Panel, and Main Tab Panel:","The menu system provides access to all functions and tools.","The Tasks Panel provides single-click access to usual protection tasks in the order you will usually perform them.","Options are explained in the Details Panel.","The Main Tab Panel provides access to the categorical features of your .NET Reactor project.","Each of these features is explained by the topics which follow."]}],[{"l":"The Main Menu","p":["- Actions","- Build/Development Tools- Here you can install the .NET Reactor Add-in for various Visual Studio versions.","- Command-line- Generate command-line parameters based on the current project settings.","- File","- Help","- Protection Presets- Applies typical configuration values to your configuration.","- Themes- Access to different .NET Reactor GUI themes.","- Tools","About - Version and EZIRIZ website access.","Bundle Tools - Create and view .NET Core 3.x, .NET 5.0+ single file application bundles.","Check for Updates - Checks if newer versions are available.","Create License File - Creates a license file according to the configuration options set on the License Manager page.","Email Support - Please read this help file carefully before mailing us questions. To report a problem read this page first.","Exit - Closes .NET Reactor.","Help - Opens Help.","License Agreement - Please read this license agreement carefully.","License Examiner - A tool that checks the license information of a license file. read more...","License Invalidation Tool - Invalidates hardware-locked license files so that a user can move a licensed installation to another system. read more...","License Reactivation Tool - Reactivates license files so that a user can use the license file again. read more...","Main Menu","New Project - Creates a new project.","Open Assembly - Loads a .NET assembly for processing by the current project.","Open Project - Opens an existing project.","Protect - Protects the current assembly using the options set in the project.","Recent Assemblies - Opens a recently opened .NET Assembly.","Recent Projects - Opens a recently opened project file.","Registration - Registers .NET Reactor to allow full use.","Save Project - Saves the open project.","Save Project As - Saves the open project as a new project.","Settings - Access to update and file format settings.","Stack Trace Deobfuscator - Uses a mapping file to deobfuscate stack traces and error messages. read more...","The menu system provides full access to functions and tools.","Web - Visit our website."]}],[{"l":"The Main Panel","p":["The main panel consists of 4 tabs. Each tab is designed to accomplish a special range of tasks and setups."]},{"l":"Files","p":["Main Panel","The Files page specifies the main assembly, additional assemblies and debug files, and general protection settings.","If you want to simultaneously protect more than one assembly or merge/pack assemblies, you must add the corresponding assemblies to this list."]},{"l":"Settings"},{"l":"General Settings","p":["Advanced Settings - Advanced embed and merge settings for the additional files.","Application Settings","Automatic Exception Handling - If you don't want your protected application to catch exceptions automatically, set this option to False.","Compression - If set to True, .NET Reactor will compress a .exe file saving space on disk and bandwidth if you provide your code for internet download.","Dead Code Removal - This option removes code that will never be executed at runtime. As the size of your assemblies are reduced it improves performance and loading time.","Digital Certificate - This node enables you to sign your protected assembly automatically with a digital code signing certificate.","Embed / Merge Settings","Embed All Assemblies- If you embed assemblies they are stored as embedded resources in the main assembly. The embedded dependencies are directly loaded from memory at runtime and are not extracted to the hard drive.","Enable Visual Styles - If you wish to use visual styles, you need to set this option to True. If set to false, any attempt in your assembly to enable visual styles will be ineffective.","Force Admin Privileges - If your software requires administrator privileges, you need to set this option to true.","In the Settings page, the General Settings node enables compression, visual styles, target file location and display of a loading screen. The bottom panel gives you a description of the currently selected property.","Merge All Assemblies - Enable this option to merge multiple assemblies into a single target assembly. Disable this option to protect all Additional Files separately.","Merge Assembly Attributes - When this option is enabled, the assembly attributes of each input assembly are copied over into the final target assembly.","Project Targets Mono Framework - Enable this option if your assembly targets Mono. A less aggressive protection approach is used, which is compatible with the Mono Framework.","Show Loading Screen - During the loading of a protected application, .NET Reactor can display a small \"loading\" screen.","Strong Name Key Pair File -.NET Reactor automates the handling of strongly named assemblies. Select your key file and specify your password, and .NET Reactor does the rest.","Target File - .NET Reactor creates a new file containing your protected assembly. This field allows you to specify the path and name of that file. If left blank, .NET Reactor will write the new file to a default location."]},{"l":"Protection Settings","p":["Anti Debug - Enable this option to detect the attachment of a debugger. In case a debugger is attached, the current process will be terminated.","Anti ILDASM / Suppress Decompilation - Enable this option to suppress decompilation using decompilation tools.","Anti Tampering - This option prevents your protected assembly from being tampered/modified by hacker tools. At runtime your protected assembly performs several binary integrity checks.","Code Virtualization - Converts your code into a set of randomized instructions which are interpreted at runtime by a virtual machine.","Control Flow Obfuscation - Control Flow Obfuscation converts the code inside your methods into spaghetti code. While retaining the function of the code, it is extremely difficult for human eyes and decompilers to follow the program logic. Decompilers cannot decompile the spaghetti code back to your original source code.","Create Mapping File - Enable Create Mapping File to create a file that cross-references unobfuscated names with obfuscated ones, which is used by the Stack Trace Deobfuscator.","Enabled - Set to True to obfuscate all nonpublic class and member names.","Exclusions - Various options to exclude classes and members from obfuscation.","Generate Short Strings - Enable this option to generate short strings for your obfuscated class and member names.","Hide Method Calls - Enable this option to hide calls to external and internal methods. Method calls are redirected through delegates which are dynamically built at runtime.","Ignore InternalsVisibleTo - Enable this option to ignore the InternalsVisibleTo assembly attribute.","Inclusions - Options to enforce obfuscation for classes and members which are normally excluded from obfuscation.","Incremental Obfuscation - If you want IntelliLock always to generate the same obfuscation strings for your type and member names, you need to enable this option.","Merge Namespaces - Enable this option to place all obfuscated types inside a single namespace. This way you can prevent multiple obfuscated namespaces for DLLs used in development environments like Visual Studio.","Naming Convention - Define how your assembly classes and members will be renamed. For most cases 'Stealth' is recommended. Read more...","Native EXE File - .NET Reactor is able to generate a native x86 EXE file stub for your application. This way it is not possible to directly open your protected application in a decompiler. The decompiler recognizes your protected application as a native EXE file.","NecroBit - NecroBit is a powerful protection technology that stops decompilation. NecroBit replaces the CIL code within methods with encrypted code. This way it is not possible to decompile/reverse engineer your method source code.","Obfuscate All Method Parameters - Enable this option to obfuscate all method parameters.","Obfuscate Public Types - By default, only nonpublic types and members will be obfuscated. Enable this option to obfuscate all classes and members in an assembly. This option is only recommended for executable files(.exe).","Obfuscation - This node allows you to choose different exclusion schemes, create a Mapping file, enable general obfuscation of class, method, property and variable names, obfuscate public types, and use unprintable characters in obfuscated names.","Pre-JIT Methods - In combination with the Native EXE File feature and NecroBit, .NET Reactor is able to convert small managed methods into REAL x86 native code. Only methods which don't affect the runtime and platform behavior (mostly small methods like property getters/setters...) are converted into native code. By nature this feature has built-in protection against assembly modification.","Public Types Internalization - If set to True, .NET Reactor will convert all public types of an application into internal ones. This way the accessibility of classes and members is reduced.","Resource Encryption & Compression - .NET Reactor can improve protection and assembly size by compressing and encrypting your managed resources. At runtime, when required the resources are automatically decompressed and decrypted.","String Encryption - Enable this option to have .NET Reactor encrypt your string constants and variables. This encryption makes it much more difficult for a hacker to attempt a native code patch of your application, as he will be unable to identify the text of messages or other useful strings, making it much more difficult to locate where to patch your code. String Encryption disguises internalized text, making it all the more difficult to decipher the interaction of your CIL.","Strong Name Removal Protection - Strong Name Removal Protection prevents your protected assembly from being tampered with by hacker tools as they cannot correctly resign the assembly with a different strong name. Warning, this option can impact the runtime performance of your protected assembly!","The Protection Settings page allows you to enable a various of protection options."]},{"l":"Lock Settings","p":["[current_minutes_days] is replaced by the current days since your application was installed (for evaluation type = Trial_Days) or the number of minutes the application has run for (for evaluation type = Runtime_Minutes)","[current_uses] is replaced by the number of times the user has run your application","[max_minutes_days] is replaced by the value specified in the \"Time\" field","[max_processes] is replaced by the value set in the \"Instances\" field for this lock","[max_uses] is replaced by the value set in the \"Uses\" field for this lock.","Dialog - Specifies whether a dialog box should be displayed to the user when the Evaluation Period expires and the message to display","Dialog - Specifies whether a dialog box should be displayed to the user when the Expiration Date is reached, and the message to display","Dialog - Specifies whether a dialog box should be displayed to the user when they attempt to run more than the specified number of instances of your application, and the message to display","Dialog - Specifies whether a dialog box should be displayed to the user when your application has been used the specified number of times, and the message to display","Enable - Enable the Nag Screen.","Enable - Enable this lock.","Enable - Enables this lock.","Enable - When set to true, this lock is enabled.","Enabled - Enable this lock.","Enabled - set to true to display a \"number of instances exceeded\" dialog box","Enabled - set to true to display a \"number of uses exceeded\" dialog box","Enabled - set to true to display an \"expiration date reached\" dialog box.","Enabled - set to true to display an evaluation period expired dialog box.","Evaluation Type - Allows you to specify two different types of trial versions :","Expiration Date - Specify the date upon which the application is to expire.","Expire When All Expired","Inbuilt Lock - Evaluation Period The Evaluation period lock enables the creation of trial versions of your application, limiting the use of your trial in a variety of ways :","Inbuilt lock - Expiration Date The Expiration Date lock allows you to specify the exact date your application should expire. This is useful, for example for beta test versions and for software rental (where you can specify the expiration date as the day following the last date the customer has paid for the use of your software).","Inbuilt Lock - Number of Uses This lock, if enabled, causes your application to expire after the specified number of uses.","Instances - The maximum number of instances.","Max Number Of Instances The max number of instances lock allows you to specify the maximum number of copies of your application the user is allowed to start simultaneously. Please note that exceeding the specified number of instances does NOT cause your application to expire.","Message - Enter the text of the message you would like to display to the user when the Evaluation Period expires. The message can be customized by .NET Reactor based on the evaluation settings by substituting various strings as follows :","Message - Enter the text of the message you would like to display to the user when the Expiration Date is reached.","Message - Enter the text of the message you would like to display to the user when the number of instances has been exceeded. The message can be customized by .NET Reactor based on the evaluation settings by substituting various strings as follows :","Message - Enter the text of the message you would like to display to the user when the number of uses has been exceeded. The message can be customized by .NET Reactor based on the evaluation settings by substituting various strings as follows :","Message - Evaluation period expired message.","Message - The text of the message to display on the nag screen.","Nag Screen We are all familiar with nag screens in applications, reminding us to purchase the product before the trial period expires. This option allows you to specify whether to display a nag screen to your user, again, without any modification to the source code of your assembly.","Note: These options are ignored for Compact Framework and Silverlight assemblies.","Once you have protected your intellectual property from theft or unintended disclosure using the .NET Reactor protection options, the next step in maximizing your revenue stream is to ensure your full version application cannot be used without purchasing a license. This is where the feature-rich .NET Reactor licensing system comes in. Using a variety of \"locks\", .NET Reactor gives you the ability to control the use of your application in a variety of ways - trial versions, software rental, software as a service - all are possible using .NET Reactor locks, and all without any modifications to your source code. We recommend that you spend some time to understand these license enforcement options as the time you invest in doing so will be time well spent.","Run Another Process After Expiration - Opens or launches another application, file, or website upon expiration. Usually used to send evaluation users to a web page.","Run Without License File - Set to false to require a valid license for operation. If true, enabled Inbuilt Locks are honored. If a valid license file is found, the Inbuilt Locks settings are overridden with the license file settings.","Runtime_Minutes - The user can run the application an unlimited number of times, for an unlimited number of days, but the application will shut down each time it is run, after the specified number of minutes.","Shut Down Process After Expiration - Terminates your application upon expiration.","Static License FileName - Specifies a license file name or extension (*.myextension). Leave blank to allow .NET Reactor to determine a *.license file name from your assembly name. To avoid conflicts with optional methods of extending license behavior, binary .NET Reactor licenses do not use the .LIC extension reserved to .NET license classes.","The Lock Settings node is where you specify the licensing controls you want .NET Reactor to build into your assembly when you protect it. These locks are implemented by additional code that .NET Reactor includes in the protected assembly and requires no changes to your application source code to implement. One of the powerful features of .NET Reactor licensing is that the settings you inbuilt into your assembly can be overridden by providing a license file to your customer, meaning you do not need to supply a separately licensed version of your program - the trial version and full version are the same, the only difference being the license file you provide to paying customers.","Time - Specify the number of days or minutes for the evaluation period.","Trial_Days - your application will work for the specified number of days from the date of the first installation on a computer.","Uses - Specify the number of times the user can run your application before it expires.","When set to False the assembly expires when any one of the locks expires. This is a very powerful option, enabling you to (for example) implement a trial period which is either 30 days or 50 uses. It is worth spending a little time considering this option's flexibility.","When set to True, causes the expiration of the assembly only when all other enabled locks have expired.","XDays - .NET Reactor can either display the nag screen every time the application is started (in which case set the value of this option to -1), or a specified number of days before the end of the Evaluation Period or Expiry Date. This is useful to allow the user a period to experience your application as if it were properly licensed, but then start to nag him as the end of the trial period or expiration date approaches."]},{"l":"Dialog Settings","p":["Dialog Box Interface - .NET Reactor will display a default dialog box whenever a message is to be displayed to the user. However, you can design your own dialog box for .NET Reactor to display. Specify the fully qualified name (namespace.dialogname) of the dialog box .NET Reactor should use. Example C# and Visual Basic projects are in the SDK/Customisable MessageBox folder within the .NET Reactor installation folder.","Dialog Caption - Title for message window.","Gradient Color Begin - Gradient Color of the message windows.","Gradient Color End - Gradient Color of the message windows.","License Not Found - The text of the message which is issued when a license file is not found (if \"Run Without License\" is set to false), is found but is corrupt or otherwise invalid."]},{"i":"so-many-dialog-boxes-","l":"So many dialog boxes !","p":["The number of possible dialog boxes may seem significant, and you may worry that your customer will see numerous dialog boxes when the locks expire. This is not the case, the .NET Reactor licensing system will only ever display one dialog to your user. .NET Reactor determines which is the most relevant dialog and displays that one only. The dialog box to display is determined as follows :","If \"Run Without License File\" is set to \"True\" and .NET Reactor cannot find the License file, or a License file is present (regardless of whether \"Run Without License File\" is true or false) and that License file is invalid, corrupt, not for the Hardware ID of the PC on which the application is run, or is invalid for some other reason, .NET Reactor will display the \"Invalid License File\" dialog;","If the application has expired, .NET Reactor will display the dialog box for the first lock, which triggered the expiry of the application in this order :","Expiration Date","Evaluation Expired","The number of uses Exceeded","If the application has not expired, the Nag screen is enabled, and the XDAYS setting is such that the NAG screen should be displayed, then the NAG screen is displayed."]},{"l":"License Manager","p":["The .NET Reactor license system allows you to distribute your assembly without a license file provided that you have set \"Run without license file\" to True. When your customer purchases a license, you use the License Manager to build a license file to unlock your application. Lock settings in a license file always override the inbuilt lock settings.","To create a valid license file, the same master key must be used for license creation as was used to protect your application. This master key is generated when you create your project, which must be saved to preserve the original key. Otherwise you will be unable to create valid license files.","The Evaluation, Expiration Date and Number of Uses Locks work precisely the same way as the inbuilt locks, except that the settings in the License file override the settings of the Inbuilt Locks.","The Individual Licensing Behaviour option is a particularly powerful feature of the .NET Reactor licensing system. If set to true, for the Evaluation Period and Number of Uses Locks, the specified number of days or uses are specific to the particular license file. For example, assume that your license file has the number of uses lock enabled and the number of uses set to 10. With \"Individual License Behaviour\" set to True, when you issue the first license to a user, he has 10 uses of the software available. If he then buys another license with the number of uses lock enabled and the number of uses set to 10, he has a further 10 uses (20 in total). If \"Individual License Behaviour\" were set to false, he would only have 10 uses in total (i.e. the 10 uses in the 2 license files are the same 10 uses). You must take care when issuing licenses with \"Individual License Behaviour\" set to true to understand that a user claiming to have lost his license file and requesting another will receive additional uses of your product. You should ensure you retain copies of issued license files so they can be re-issued to users who lose their licenses to prevent this.","License Files also introduce a new type of lock - the Hardware Lock. This allows you to create licenses that can be used only on a particular PC, based on a Hardware ID that identifies the particular combination of hardware in that PC. License Files which have the Hardware disabled can be used on any PC. Utilizing the Hardware Lock prevents your customer from purchasing one license file and using it on multiple PCs.","To create licenses that are locked to a particular PC's hardware, you must enable \"Hardware Lock\" and provide the Hardware ID of the client's PC. You can use the .NET Reactor SDK library License.dll to display the Hardware ID from within your application (for example in the \"About\" dialog box), or provide your customer with a program that will display the Hardware ID.","Additional information can be added to the license file at this time with the Add tool. Your application can access this information with the functions available in the SDK libraries."]},{"i":"net-inspector","l":".NET Inspector","p":[".NET Inspector reflects extractable information from the main assembly."]}],[{"l":"Additional Assemblies","p":["If you want to protect more than one assembly simultaneously or merge/ embed assemblies, you must add the corresponding assemblies to this list.","Click \"Scan Main Assembly Dependencies\" to scan the dependencies of the main assembly and add them to the list.","For mixed settings (merge one assembly and embed the other one) click \"Advanced Merge & Embed Settings\"."]}],[{"l":"Additional License Information","p":["License Information","Additional information can be added to the license file with this tool. Your assembly can optionally process this information with the functions available in the SDK libraries."]}],[{"l":"License File Settings","p":["Via the License File Settings it is possible to lock your license files with different locks. This way the valid license file is only valid for a specific time (e.g. 1 year, 100 uses ...).","To generate licenses which are only valid on a specific machine, you must enable \"Hardware Lock.\" To programmatically extract the hardware ID, please use the .NET Reactor SDK library License.dll. The client sends the hardware ID to you, which the License Manager uses to output a valid, machine-specific license.","Individual Licensing Behaviour- If you set this option to \"True\", each license file you create will use its own independent lock data for the evaluation period/evaluation type, Expiration Date, and/or Number of Uses locks. If a license file has expired, this allows you to easily create a new license file with this option set to \"True\" and new evaluation period parameters set. The trial period for this license file begins at 0 again. If you want all license files (with the same master key) to share the same lock data, you set this option to \"False\". With Individual Licensing Behaviour set to True, you can implement licensing schemes such as \"software as a service\" whereby your customer purchases a number of uses of your software. Each time your customer purchases more uses of your software, you issue him with another License file, with Individual License Behaviour set to \"True\", enable the Number of Uses lock and set the number of uses to the amount the customer has purchased."]}],[{"l":"License Manager","p":["The .NET Reactor license system allows you to distribute your assembly without a license file. You provide a license file to unlock your protected/locked assembly. The License Manager builds license files.","To create valid license files, the same master key must be used for license creation as was used to produce .NET Reactor protected output. This master key is generated when you create your project, which must be saved to preserve the original key.","To generate licenses that are only valid on a specific machine, you must enable \"Hardware Lock.\" To programmatically extract the hardware ID, please use the .NET Reactor SDK library License.dll. The client sends the hardware ID to you, which the License Manager uses to output a valid, machine-specific license.","Additional information can be added to the license file at this time with the Add tool. Your assembly can optionally process this information with the functions available in the SDK libraries."]}],[{"l":"Main Assembly","p":["To protect your .NET software, you need to define the main assembly. You can add further .NET files in the Additional Assemblies list."]}],[{"l":"Master Key","p":["A master key is a cryptographic asymmetric key (RSA) used to encrypt, sign and validate license files. The public part of the master key is stored inside the protected assembly and is automatically used to validate loaded license files whilst the private part of the master key is used to encrypt and sign those files.","In addition the master key defines a \"slot\" where information like evaluation periods, expiration dates, numbers of uses, etc. are stored. If you change the master key a different slot would be used. If you protect different assemblies with different master keys, they would each use their own slots. For example, if you want multiple assemblies to share the same number of uses, you would need to protect them with the same master key.","When you create license files for your protected software, you must use the same master key that you used to produce the .NET Reactor protected output.","This master key is generated when you create your project, which must be saved to preserve the original key. Never hand out the Master Key to anybody!"]}],[{"l":"Understanding The License System","p":[".NET Reactor's pre-built licensing system observes high-security standards, and in prevalent cases, will fulfill or exceed the proprietary security and convenience your enterprise might develop at considerable expense or difficulty.","Most needs will be met by simply deploying hardware identity locks. Nonetheless, the .NET Reactor License System is designed to readily fit practically any further need or automation.","If you deploy our prebuilt system with hardware (machine-specific) license locks, licensing of initial product releases can readily be handled manually with .NET Reactor itself at a clip of about a minute per license — allowing you to release protected wares just minutes after purchasing .NET Reactor. Later (if you want), practically any desirable degree of automation can be integrated through the .NET Reactor Software Development Kit (SDK).","You can deploy independent, proprietary license enforcement. Or you can rely on .NET Reactor's prebuilt license enforcement system to any degree you desire. You can pursue two basic licensing paths — prebuilt licensing, or extended (customized) proprietary licensing. The latter can build upon our prebuilt hardware identifying system or integrate proprietary processes with information you can embed in our binary license files. In either approach, prebuilt .NET Reactor processes make it easier to produce secure, inviolable licensing systems than native .NET SDKs.","A critical security feature of this system is that in no way and at no time does any code exist outside your premises which is necessary to determining valid licenses. .NET Reactor's binary licensing system is exceedingly secure."]},{"l":"Step 1. Protect Your Software"},{"l":"Step 2. License File Generation"},{"l":"Step 2b. License File Generation Via SDK"},{"l":"Step 3. Activation"}],[{"l":"How Locks Work","p":["By imposing locks on your software, you can freely distribute your product for trial or evaluation and rely upon lock expiration to compel the purchase of your wares when the evaluation period expires. When software locks expire, your prospective client must purchase a valid license.","You can also set Evaluation Time, Expiration Date, and Number of Uses limits in issued licenses. When license locks expire, your customer must acquire a further license to use your product further.","By combining software and license locks, you can impose any limitations on the software use you desire. Most importantly, without writing a line of code to do so, you can show off your wares to your market."]}],[{"l":"General Information","p":["The .NET Reactor SDK consists of 3 DLLs and one EXE.","License.dll- With this .NET library, you can determine the current license status of your locked software at runtime. You can also extract the hardware ID of the current machine and invalidate a license.","LicenseGen.dll- The library LicenseGen.dll contains the class \"LicenseGenerator\". It enables you to create license files on the fly without using the .NET Reactor GUI (License Manager). It is not intended to use this library on end-user systems. Mainly it is used on license servers.","StackTraceDeobfuscator.dll- The library StackTraceDeobfuscator.dll contains the class \"Eziriz.StackTraceDeobfuscator\". Using this class and a mapping file, you can deobfuscate error messages."]}],[{"i":"licensedll","l":"License.dll","p":["Check if a confirmation code is valid","Check if a valid license file is available","Check the license status of Evaluation Lock","Check the license status of Expiration Date Lock","Check the license status of Hardware Lock","Check the license status of Number Of Instances Lock","Check the license status of Number Of Uses Lock","Compare current Hardware ID with Hardware ID stored in License File","Get Hardware ID of the current machine","Get loaded license (if available) as byte array","How To Examples:","Invalidate the license","Manually load a license using a filename","Manually load a license using byte array","Please note that the methods and properties of \"License.dll\" only return the correct values after protecting your software. After protection, the library \"License.dll\" is not further required. This means you can ship your protected software without License.dll.","Reactivate a license","Read additional license information from a license license","Reference Namespace of License.dll","With the .NET library \"License.dll\", you can determine the current license status of your locked software at runtime. You only need to reference this library in your project and access the corresponding methods and properties. All methods and properties should be self-explanatory. You don't need to select a license file. If a valid license file is available, it will be used automatically to update the license status."]},{"i":"how-to-example-code","l":"How To Example Code:","p":["​ Check the license status of Expiration Date Lock","Check if a confirmation code is valid","Check if a valid license file is available:","Check the license status of Evaluation Lock:","Check the license status of Hardware Lock","Check the license status of Number Of Instances Lock","Check the license status of Number Of Uses Lock","Compare current Hardware ID with Hardware ID stored in License File","Get Hardware ID of the current machine","Get loaded license (if available) as byte[]","Invalidate the license","Manually load a license using a filename","Manually load a license using byte[]","Reactivate the license","Read additional license information from a license license:","Reference Namespace of License.dll:"]}],[{"i":"licensegendll","l":"LicenseGen.dll","p":["LicenseGen.dll contains the class \"LicenseGenerator\". It enables you to create license files on the fly without using the .NET Reactor GUI (License Manager). It is not intended to use this library on end-user systems. Mainly it is used on license servers."]},{"i":"create-a-license-file","l":"Create a License File:"}],[{"i":"stacktracedeobfuscatordll","l":"StackTraceDeobfuscator.dll","p":["The library StackTraceDeobfuscator.dll contains the class \"Eziriz.StackTraceDeobfuscator\". Using this class and a mapping file, you can deobfuscate error messages.","How To Examples:","Reference Namespace of StackTraceDeobfuscator.dll","Deobfuscate an obfuscated text/stack trace"]},{"i":"how-to-example-code","l":"How To Example Code:","p":["Reference Namespace of StackTraceDeobfuscator.dll","Deobfuscate an obfuscated text/stack strace"]}],[{"i":"net-bundling","l":".NET Bundling","p":["Enable this option to create a .NET (Core) single file application. The executable is self-extracting and contains all dependencies (including native) required to run your app. When the app is first run, the application is extracted to a directory based on the app name and build identifier. The startup is faster when the application is run again. The application doesn't need to extract itself a second time unless a new version is used."]}],[{"l":"Anti Debug","p":["This option will enable anti-debugger detections inside the protected assembly. In case a debugger is attached, the current process will be terminated."]}],[{"l":"Anti ILDASM","p":["This feature suppresses decompilation using decompilation tools. Decompilation tools (like ILDASM - the Microsoft Intermediate Language disassembler) will report that they cannot open the protected assemblies.","This feature also stops the analysis of bundled applications (self-contained .NET (Core) single application files)."]}],[{"l":"Anti Tampering","p":["This option prevents your protected assembly from being tampered/modified by hacker tools. At runtime your protected assembly performs several binary integrity checks."]}],[{"l":"Code Virtualization","p":["The Common Intermediate Language (CIL) is a set of platform-independent instructions generated by the language-specific compiler (C#, VB.NET...) from the source code. The CIL is platform-independent and can be executed on any Common Language Infrastructure supported environments such as the .NET runtime or Mono.","The way how the CIL and other metadata is stored must follow a specific standard (ECMA-335). This way tools like .NET Reflector or ILSpy can read the CIL instructions and translate the code back to its source language (C#, VB.NET...).","Code Virtualization converts the CIL code into a set of randomized instructions which are interpreted at runtime by our virtual machine. As there is no standardized procedure to interpret the new instruction set correctly, the original CIL instructions can't be reconstructed. Consequently, the virtualized code can't be translated back to its source language.","As the performance of virtualized methods is significantly decreased, code virtualization should only be applied to selected methods.","To enable code virtualization you need to decorate the corresponding methods with the following attribute:"]},{"l":"Example Usage","p":["Before:","After Protection (decompiled with ILSpy):","Code Virtualization After","The remaining stub code executes the virtual machine."]}],[{"i":"compress--encrypt-resources","l":"Compress & Encrypt Resources","p":[".NET Reactor can improve protection and assembly size by compressing and encrypting your managed resources. At runtime, when required the resources are automatically decompressed and decrypted."]}],[{"l":"Control Flow Obfuscation","p":["Control Flow Obfuscation converts the code inside your methods into spaghetti code, which whilst retaining the function of the code makes it extremely difficult for human eyes and decompilers to follow the program logic. Decompiler are not able to decompile the spaghetti code back to your original source code.","Before (decompiled with ILSpy):","Before Control Flow Obfuscation","After (decompiled with ILSpy):","After Control Flow Obfuscation"]}],[{"l":"Declarative Protection","p":["The .NET Reactor user interface offers various ways to refine the level of protection applied to your application. The Advanced Rules editor allows you to select different inclusion and exclusion options, and you can also control the protection level using the standard .NET Obfuscation Attribute.","If you want .NET Reactor to respect this attribute, you must enable the Declarative Protection option in the settings:","Once you have enabled this option you can use the attribute to select specific protection features, choose whether to include or exclude those features, and specify the classes and members that should be affected."]},{"l":"Selecting Protection Features","p":["Protection features can be selected by assigning values to the attribute Feature property.","The following values are available:","\"renaming or \"obfuscation\"","\"stringencryption\"","\"controlflow\"","\"necrobit\"","\"antitamp\"","\"hidemethods\"","Important: The values must be entered with the quotation marks and are case insensitive."]},{"l":"Defining the behavior","p":["Use the Exclude property to define whether the features should be included or excluded.","To include features, set the Exclude property to false.","To exclude features, set the Exclude property to true. The default value is true, so explicitly setting the Exclude property is optional if you wish to exclude a feature."]},{"i":"placing-the-attribute-and-the-applytomembers-property","l":"Placing the attribute and the 'ApplyToMembers' property","p":["You can place the attribute on top of classes and members (methods, properties, and fields).","The ApplyToMembers property has a default value of true. As it only affects whether class members (methods, properties, fields, and nested classes) are affected, it is only appropriate for attributes decorating a class.","If you do not want the class members to be affected, set the ApplyToMembers property to false."]},{"l":"Examples","p":["Example 1:","MyClass, NestedClass, and MyMethod will not be renamed.","Example 2:","This is equivalent to Example 1.","Example 3:","Only MyClass is excluded from renaming, but not NestedClass and MyMethod.","Example 4:","Only MyField and MyMethod2 will be renamed.","String Encryption will be applied to MyMethod and MyMethod2","NecroBit will be only applied to MyMethod2."]},{"i":"special-case-systemreflectionobfuscation","l":"Special case: [System.Reflection.Obfuscation()]","p":["There is a special case that works independently from \"Declarative Protection\". If you don't set a value for the Feature property, the attribute excludes renaming.","Example 5:","Only MyClass is excluded from renaming, but not NestedClass and MyMethod.","Example 6:","MyEnum and all fields are excluded from renaming.","Example 7:","Only the B field is excluded from renaming."]},{"l":"Assembly Attributes","p":["In addition to the standard Obfuscation attribute usage described above, you can define more complex, rule-based configurations via assembly attributes. These rules allow for finer-grained control over protection features and can be combined with filters specifying which classes, interfaces, enums, methods, properties, fields, or events they affect.","These rules are defined in the Feature property of the Obfuscation attribute using a special syntax starting with rule: or rule regex:."]},{"l":"Basic Syntax for Rules","p":["The structure is as follows:"]},{"i":"rule-or-rule-regex","l":"rule: or rule regex:","p":["rule: indicates a standard rule set.","rule regex: indicates that all defined names (namespaces, types, methods, fields, properties, events) are interpreted as regular expressions.","( ... )– The first parentheses block defines which features to enable or disable.","Prefix + means enabling/applying a feature.","Prefix - means excluding/disabling a feature."]},{"i":"available-features","l":"Available Features:","p":["-all: Disables all features for the listed filter elements.","-virtualization / +virtualization: Disables/Enables Code Virtualization for the listed filter elements.","-controlflow / +controlflow: Disables/Enables Control Flow Obfuscation.","-hidemethods / +hidemethods: Disables/Enables Hide Method Calls.","-necrobit / +necrobit: Disables/Enables NecroBit.","-renaming / +renaming: Disables/Enables Renaming.","-resourceencryption / +resourceencryption: Disables/Enables Resource Encryption.","-stringencryption / +stringencryption: Disables/Enables String Encryption.","Multiple features can be combined and must be comma-separated. For example:"]},{"i":"where---","l":"where ( ... )","p":["This section is optional and defines a filter on the types. If omitted, the rule applies to all types. The following values can be used (one per where(...) clause):","class– Affects all classes but no enums.","compiler– Affects all compiler-generated types.","enum– Affects only enums.","event– Affects only events.","interface– Affects only interfaces.","member_attr– Affects only members that have a special type attribute defined in the next filter.","type_attr– Affects only types that have a special type attribute defined in the next filter.","interface_impl– Affects only types that have implemented certain types defined in the next filter.","public_interface_impl– Affects only types that have implemented certain public types defined in the next filter.","inherited– Affects only types that are inherited from certain types defined in the next filter.","inherited_public– Affects only types that are inherited from certain public types defined in the next filter.","nested_excl– Affects only types containing nested excluded types."]},{"i":"--","l":"( ... )","p":["The next filter is again optional. If nothing is defined, it means all types in all namespaces are considered. You can specify a namespace and a list of types within it to restrict which elements the rules apply to:"]},{"i":"---1","l":"( ... )","p":["The last filter is also optional and further restricts which members are affected. If not set, everything from the previously defined classes is selected. Possible values are:","-typenames– Typenames will not be renamed.","-namespaces– Namespaces will not be renamed.","-methods– No methods will be renamed.","-fields– No fields will be renamed.","-properties– No properties will be renamed.","methods:– A list of multiple methods, comma-separated.","fields:– A list of multiple fields, comma-separated.","properties:– A list of multiple properties, comma-separated.","events:– A list of multiple events, comma-separated.","For example:"]},{"l":"Using Regex","p":["When using rule regex:, any name (namespace, type, method, field, property, event) you specify after methods=, fields=, properties=, events=, namespace=, or types= is treated as a regular expression."]},{"l":"Complete Example"},{"i":"explanation","l":"Explanation:","p":["rule: (-renaming,-necrobit,+stringencryption) Disables Renaming and NecroBit, enables String Encryption.","where (interface_impl) Applies this rule only to types that have implemented the defined interfaces in the next filter.","(namespace=MyNamespace; types=Interface1,Interface2) Interfaces Interface1 and Interface2 within MyNamespace.","(-typenames; -namespaces; methods=MyMethod,MyMethod2; properties=MyProperty,MyProperty2) From the selected types, do not rename the type names or namespaces, but apply these rules specifically to methods named with name MyMethod and MyMethod2 and properties MyProperty and MyProperty2."]},{"i":"further-examples","l":"Further examples:","p":["All these combined filters allow very fine-grained configuration of the obfuscation process directly from within your code using Obfuscation attributes.","How to Generate Assembly Attributes from Advanced Rules Editor:","If you prefer to set up rules visually and then generate the corresponding attributes:","In .NET Reactor, go to 2. Protection Settings -> Advanced Rules.","Define or select your rules from the GUI.","Right-click on the selected rules and choose \"Generate Assembly Attributes\"."]}],[{"l":"Embed Assemblies","p":[".NET Reactor takes the assemblies (listed in Additional Assemblies) and embeds them inside the Main Assembly.","Embedding dependencies inside the executable helps you to deploy and maintain your software as you can embed all dependencies into a single efficient executable file. At runtime, the embedded dependencies are directly loaded from memory and are not extracted to the hard drive. .NET Reactor doesn't apply any protection to the embedded assemblies. If you want to protect embedded assemblies you should merge them with the main assembly or protect them first."]}],[{"l":"EvaluationLock","p":["Enable Evaluation_Lock if you want your protected assembly only to be used for a limited time. Choose between \"Runtime_Minutes\"(minutes) and \"Trial_Days\"(days). This lock turns your software into a \"Trial Edition\"."]}],[{"l":"HardwareLock","p":["Enable Hardware Lock if you want to link a license file to a specific machine. The created license file is only valid on a machine with the defined hardware ID. To get the hardware ID, please use the .NET Reactor SDK library License.dll."]}],[{"l":"Hide Methods Calls","p":["Hide calls to external and/or internal methods. Method calls are redirected through delegates which are dynamically built at runtime.","Usually it is sufficient to hide only external method calls.","Before (decompiled with ILSpy)::","Hide Metod Calls Before","After (decompiled with ILSpy):","Hide Metod Calls After","After (decompiled with ILSpy)(with Obfuscation -> Naming Convention -> Stealth):","Hide Metod Calls After With Stealth"]}],[{"l":"License File","p":["A valid license file unlocks your locked .NET software. To create a valid license file the correct master key must be loaded. It must be the same master key as you used to protect your software. You can create license files via the License Manager."]}],[{"l":"Mapping File","p":["To deobfuscate stack traces you require a mapping file. A mapping file contains the translation for all obfuscated names. The stack trace deobfuscator requires mapping files to reconstruct the original stack trace."]}],[{"l":"Master Key","p":["A master key is a cryptographic asymmetric key (RSA) used to encrypt, sign and validate license files. The public part of the master key is stored inside the protected assembly and is automatically used to validate loaded license files whilst the private part of the master key is used to encrypt and sign those files.","In addition the master key defines a \"slot\" where information like evaluation periods, expiration dates, numbers of uses, etc. are stored. If you change the master key a different slot would be used. If you protect different assemblies with different master keys, they would each use their own slots. For example, if you want multiple assemblies to share the same number of uses, you would need to protect them with the same master key.","When you create license files for your protected software, you must use the same master key that you used to produce the .NET Reactor protected output.","This master key is generated when you create your project, which must be saved to preserve the original key. Never hand out the Master Key to anybody!"]}],[{"l":"Merge Enums","p":["The \"Merge Enums\" feature combines different enums into fewer ones. This can make it harder for people to understand or reverse-engineer the original code.","When the same merged enum is used across multiple classes, it can give the impression that these classes are interconnected or share dependencies through enum values, even if they’re unrelated. This can mislead anyone attempting to trace logical flows or dependencies, complicating the interpretation of the code structure. Additionally, reverse engineers will be unable to determine how many distinct enums were present in the original assembly.","Only enums that are renamed by .NET Reactor during the obfuscation process will be merged. Furthermore, enums of the same type (typically int32) are grouped and merged within corresponding groups."]}],[{"l":"Merge Assemblies","p":["Enable this option to merge multiple assemblies into a single target assembly. .NET Reactor takes your assemblies ( Main Assembly and assemblies listed in Additional Assemblies) and merges them into one target assembly.","Merging dependencies improves the protection of your software. The merged dependencies are no longer visible to the user and as they are a real part of the main assembly they are automatically protected as well. If the main assembly is an executable, the target assembly is still an executable with the same entry point.","3rd party libraries are often already protected and it is not recommended to merge them with the main assembly. If you have troubles merging assemblies you should embed them inside the main assembly instead.","* Disable this option to protect assemblies listed in Additional Files separately."]}],[{"l":"Naming Convention","p":[".NET Reactor offers various schemes of how your classes and members will be renamed during obfuscation.","Debug- Debug adds the prefix 'Δ_' to the original names. This makes it easy to see which classes and members are are renamed through obfuscation. It's not recommended to distribute software with this naming convention.","Naming Convention Debug","Incremental- If you want .NET Reactor always to generate the same obfuscation strings for your type and member names, you need to enable this option.","Naming Convention Incremental","Standard- This is the default scheme.","Naming Convention Default","Stealth- Generates random, meaningful names for obfuscated classes and members. This way it is less obvious which parts are obfuscated. For most cases 'Stealth' is the recommended option.","Naming Convention Stealth","Strange- Uses weird and displaced characters which confuse most decompiler code views. Only enable this feature if you don't want to use the protected assembly in a development environment(Visual Studio etc.).","Naming Convention Strange","Unprintable Characters- Uses unprintable strings to obfuscate type and member names. Only enable this feature if you don't want to use the protected assembly in a development environment(Visual Studio etc.).","Naming Convention Unprintable"]}],[{"l":"Native EXE File","p":[".NET Reactor is able to generate a native x86 EXE file stub for your application. This way it is not possible to directly open your protected application in a decompiler. The decompiler recognizes your protected application as a native EXE file."]}],[{"l":"NecroBit","p":["NecroBit is a powerful protection technology which provides complete protection for your sensitive intellectual property by replacing the CIL code within methods with encrypted code. This way it is not possible to decompile/reverse engineer your method source code.","Before (decompiled with ILSpy):","Before NecroBit","After (decompiled with ILSpy):","After NecroBit"]}],[{"l":"Obfuscation","p":["In addition to source protection, .NET Reactor provides thorough class and member obfuscation complemented by different exclusion schemes, use of non-printable characters in obfuscated names, and even incremental obfuscation, which always generates the same obfuscation strings for type and member names.","Obfuscation mangles type and member names. The obfuscation process converts a program into an equivalent one that is much more difficult to reverse engineer. The advantage of this method is that it runs on standard hardware and without any changes to virtual machines or available interpreters.",".NET Reactor fully supports declarative obfuscation. Declarative obfuscation allows you to directly define which types and members should be excluded from obfuscation. This can be done by using the custom attribute System.Reflection.ObfuscationAttribute in your source code. .NET Reactor automatically detects the attribute and excludes the corresponding types and members from obfuscation.","The Obfuscation node:","Create Mapping File - Enable Create Mapping File to create a file which cross-references unobfuscated names with obfuscated ones, which is used by the Stack Trace Deobfuscator.","Enabled - Set to True to obfuscate all nonpublic class and member names.","Exclusions - Select the kind of types you want to prevent from obfuscation.","Incremental Obfuscation - If you want IntelliLock always to generate the same obfuscation strings for your type and member names, you need to enable this option.","Obfuscate Public Types - Enable it to obfuscate all types and member names.","Obfuscate Serializable Types - Disable this option to prevent serializable types from obfuscation.","Use Unprintable Characters - Unprintable characters use unprintable strings to obfuscate type and member names but cannot be used if your assembly must run as safe code.","Example (decompiled with ILSpy):","Obfuscated Assembly"]}],[{"l":"Pre-JIT Methods","p":["In combination with the Native EXE File feature and NecroBit, .NET Reactor is able to convert managed methods into REAL x86 native code. Only methods which don't affect the runtime and platform behavior (mostly small methods like property getters/setters...) are converted into native code. By nature this feature has built-in protection against assembly modification."]}],[{"l":"String Encryption","p":["String encryption makes it difficult for a hacker to understand your code and attempt a code patch of your assembly, as he will be unable to identify the text of messages or other useful strings, making it much more difficult to identify where to patch your code. This feature has built-in protection against assembly manipulation.","Before (decompiled with ILSpy):","Before String Encryption","After (decompiled with ILSpy):","After String Encryption"]}],[{"l":"Advanced Rules Editor"},{"l":"Introduction","p":["The Advanced Rules Editor provides a visual way to configure the same obfuscation and protection settings available via [assembly: Obfuscation(Feature=...)] attributes in your code ( see here). Instead of writing assembly attributes by hand, you can use the GUI to:","Create Rules that specify which features (e.g., Renaming, ControlFlow, Virtualization, StringEncryption, etc.) to enable or disable.","Apply those Rules selectively to certain assemblies, namespaces, types, methods, fields, properties, or events.","Use Regular Expressions for matching names if you need advanced filtering.","Generate the corresponding [assembly: Obfuscation(Feature=...)] attributes from your visual settings, allowing you to include them directly in your project if you wish."]},{"l":"1. Accessing the Rules Editor","p":["In .NET Reactor, go to 2. Protection Settings -> Advanced Rules.","Click on Add to create a new rule or select an existing rule to edit or clone."]},{"l":"2. Overview of the Rules Editor Interface","p":["When you open the Rules Editor, you will see two main sections:","Rules List(top section):","Displays all configured rules in a table, including columns for Rule Name, Rules Type, Assemblies, Namespaces, and Types.","You can quickly enable or disable a rule by checking or unchecking it in the Active column.","The Filter dropdown (at the top) allows you to filter which rules are currently displayed (e.g., show only renaming rules, show all rules, etc.).","Rule Configuration(bottom section):","Here is where you specify the details of the selected rule.","Name and Comments fields let you describe your rule.","A Rules Type area (e.g., “Exclude Renaming” in the screenshot) indicates which obfuscation features are being turned on/off. You can toggle checkboxes (e.g., Type Names, Namespaces, Methods, Fields, Properties, etc.) or specify method/property names to include or exclude from renaming or from other features.","The Use Regular Expressions option allows the typed values (e.g., method or property names) to be interpreted as regex patterns.","The Where section lets you narrow down the rule to certain assemblies, namespaces, or specific types. You can also specify filters for Access Modifiers(e.g., public, private)."]},{"l":"3. Adding or Editing a Rule","p":["Access Modifier filters (e.g., All Access Modifiers, +public, -internal) are also available. This lets you, for example, exclude only protected members from renaming while allowing private members to be renamed.","Assemblies: If multiple assemblies are loaded in your project, you can select which ones get this rule. By default, “All Assemblies” is selected.","Choose the type of rule you want to apply or exclude. For instance,“Exclude Renaming,” “Enable ControlFlow,” etc.","Click “Add” to create a new rule and/or select a rule to bring up the detailed editor (the lower section).","Comments: Add any notes you want to remember later (optional).","Depending on the selected rule type, you might see input fields and checkboxes for:","Features Section:","If the rule is an Exclude-type rule (e.g., “Exclude Renaming”), then those checked items will be excluded from renaming.","If you check this box, all the name-based fields (methods, fields, properties, events, namespace, types) will be interpreted as regular expressions. This is equivalent to using rule regex: in the [Obfuscation(Feature=...)] syntax.","Namespace: Enter the namespace that this rule should target(e.g., My.Namespace).","Narrow down the rule by specifying:","Rule Name: Provide a descriptive name (e.g., “PreventRenaming_MyCriticalTypes”).","Save your rule by clicking OK(or “Apply”) in the dialog. The new rule will be added to the list at the top.","To specify a particular set of methods, properties, or events by name, enter them in the text box (comma-separated). You can also use the ... button to add the names to a list and define access modifiers.","Type Names/ Namespaces/ Methods/ Fields/ Properties/ Events","Types: Enter specific types (e.g., MyType, MyType2+MySubClass). The plus sign denotes a nested type or sub-class. You can also leave the Namespace field empty and define full type names here.","Use Regular Expressions:","When checked, it means that category is included in the rule.","Where(Filters):"]},{"l":"4. Rule Priority and Conflicts","p":["Typically, rules are processed top to bottom.","As a rule of thumb, place the more specific or narrower rules after the more general rules so that the narrower rule can take precedence."]},{"l":"5. Generating Assembly Attributes","p":["You can easily convert your configured visual rules into assembly attributes:","Right-click on a rule (or a selection of rules) and choose “Generate Assembly Attributes”. Alternatively you can use the corresponding menu items.","The attributes are copied to the clipboard."]},{"i":"6-tips--best-practices","l":"6. Tips & Best Practices","p":["Use Comments: Document within the rule editor what each rule does, especially if you share the project with other developers.","Check Overlaps: Make sure that overlapping rules do not create unintended results.","Regular Expressions: Use them with caution—overly broad patterns can accidentally match more types/members than you intended."]},{"l":"7. Examples"},{"i":"example-1-exclude-renaming-for-all-classes","l":"Example 1: Exclude Renaming for All Classes","p":["All classes and their members in every assembly are excluded from renaming."]},{"i":"example-2-exclude-renaming-for-specific-types","l":"Example 2: Exclude Renaming for Specific Types","p":["Class names and members of MyNamespace.Type1 and MyNamespace.Type2 are excluded from renaming."]},{"i":"example-3-exclude-renaming-for-specific-types-alternative-approach","l":"Example 3: Exclude Renaming for Specific Types (Alternative Approach)","p":["Same as Example 2, but without using the Namespace field."]},{"i":"example-4-exclude-renaming-for-a-full-namespace","l":"Example 4: Exclude Renaming for a Full Namespace","p":["Everything in MyNamespace is excluded from renaming."]},{"i":"example-5-exclude-renaming-for-classes-ending-with-resource","l":"Example 5: Exclude Renaming for Classes Ending with \"Resource\"","p":["Any class whose name ends with “Resource” is excluded from renaming."]},{"i":"example-6-exclude-renaming-for-internal-classes-matching-special-under-namespaces-starting-with-my","l":"Example 6: Exclude Renaming for Internal Classes Matching \"Special\" Under Namespaces Starting with \"My\"","p":["All internal classes containing “Special” in their names, located in namespaces starting with “My” are excluded from renaming."]},{"i":"example-7-exclude-renaming-for-fields-and-specific-methods-in-one-type","l":"Example 7: Exclude Renaming for Fields and Specific Methods in One Type","p":["Fields and methods Method1/Method2 in MyNamespace.MyType1 are excluded from renaming. The type name itself, properties, and events in MyType1 remain subject to renaming."]},{"i":"example-8-exclude-renaming-for-internal-methods-starting-with-special-in-one-class","l":"Example 8: Exclude Renaming for Internal Methods Starting with \"Special\" in One Class","p":["Internal methods whose names begin with “Special” in MyNamespace.MyType1 are excluded from renaming."]},{"i":"example-9-exclude-renaming-for-classes-derived-from-a-specific-base-type","l":"Example 9: Exclude Renaming for Classes Derived from a Specific Base Type","p":["All classes that inherit from MyNamespace.MyBaseType are excluded from renaming."]},{"i":"example-10-exclude-renaming-for-classes-decorated-with-a-specific-attribute","l":"Example 10: Exclude Renaming for Classes decorated with a specific Attribute","p":["Any class marked with [JsonObject] is excluded from renaming."]},{"i":"example-11-exclude-string-encryption-for-methods-decorated-with-a-specific-attribute","l":"Example 11: Exclude String Encryption for Methods Decorated with a specific Attribute","p":["Methods marked with [JsonPropertyName] are excluded from string encryption."]}],[{"l":"Build Integration Manager","p":["The Build Integration Manager seamlessly integrates .NET Reactor into your build process. You can access it via the .NET Reactor main menu under Build/Development Tools→ Build Integration Manager.","This manager can be opened in multiple ways:","Main menu: Click Build/Development Tools→ Build Integration Manager.","Drag and drop: Drag project files from Visual Studio 2022 or Rider directly from the IDE onto the .NET Reactor main window. Additionally, dragging and dropping files via Windows Explorer or macOS Finder is supported.","Rider and Visual Studio Add-ins: The add-ins also use the Build Integration Manager."]},{"l":"Selecting a Solution File","p":["Choose a solution (.sln) file in the manager. When using Drag and drop or Rider and Visual Studio Add-ins, the solution is automatically selected.","The manager lists:","All referenced projects in the solution.","All available build configurations for each project (in alphabetical order).","Use the checkboxes next to each configuration to activate them for .NET Reactor protection. The project outputs of these activated configurations will be automatically protected when built."]},{"l":"Defining a .NET Reactor Project File","p":["Within the Build Integration Manager, you can optionally specify a .NET Reactor project file:","The protection and licensing settings of this project file will be used to protect the assemblies.","You can also pass command-line parameters(see below) in addition to (or instead of) the project file."]},{"l":"Output File","p":["The Output File field is optional. Its default value is: AssemblyLocation\\AssemblyFileName","This means that the assemblies in the final output folder (e.g., bin\\Debug or bin\\Release) will be directly replaced with the protected versions. You can override this setting if you wish to store the protected files elsewhere."]},{"l":"Command-line Parameters","p":["You can also provide command-line parameters that .NET Reactor will use in addition to (or instead of) a project file. You can combine them with an existing .NET Reactor project file for more granular control.","When using a full version of .NET Reactor, it is recommended that you add the -licensed parameter. If this parameter is provided while running a demo version, the build will fail with error code 101— preventing accidental protection with the demo version (which would cause your software to stop working after 2 weeks)."]},{"l":"Protection Timing","p":["This is a critical setting that determines when.NET Reactor will protect your assemblies during the build process. The following options are available:","After Build (default).NET Reactor protects the assembly after it is copied into the final output directory (usually bin\\Debug or bin\\Release). This is the standard approach for most projects.","After Compile.NET Reactor protects the assembly earlier, when the files are still in the obj folder, before they are copied to the final folder.","This is useful for deployment or publishing processes (e.g., setup projects, MAUI apps) that take the assemblies from the obj folder instead of the final output folder.","If your installers or publishing processes are not including the protected files, switching to After Compiler should resolve the issue.","After Publish.NET Reactor protects the assembly after the project is published. There is no widely known practical use case, but it's available if you need an even later protection step."]},{"l":"Project File Modifications","p":["To integrate .NET Reactor into the build, the corresponding project files (e.g., .csproj, .vbproj) are updated. Furthermore a new file ending with .dotnet_reactor.targets is added."]},{"l":"Build Environments","p":["Projects modified by the Build Integration Manager will work automatically on Windows and macOS if:",".NET Reactor is installed via its installer, or","You use the .NET Reactor Azure DevOps Pipelines Task, or","You use the .NET Reactor GitHub Action."]},{"l":"Other Build Environments","p":["If you are building in other environments, you need to set the environment variable DOTNETREACTORROOT(or DOTNET_REACTOR, both are recognized) to the directory containing the .NET Reactor binaries. This ensures the MSBuild targets can locate and execute .NET Reactor properly."]},{"l":"Actions Menu","p":["When working with many projects and configurations, the Actions menu can help you quickly configure multiple items at once. The available actions are:","Selected Configuration → Copy Settings Copies the current configuration’s settings (e.g., project file path, output file location, command-line parameters, etc.).","Copied Settings → Selected Configurations Applies the copied settings to all currently selected configurations.","Copied Settings → All Active Configurations Applies the copied settings to every configuration that is activated(checked).","Copied Settings → All Debug Configurations Applies the copied settings to all Debug configurations in the list.","Copied Settings → All Release Configurations Applies the copied settings to all Release configurations in the list.","This can be a significant time-saver if you need to update protection settings across multiple projects."]},{"l":"Filter Textbox","p":["To help locate relevant configurations among many projects, the Filter textbox allows you to quickly search and display only the matching configurations. This is especially helpful for large solutions with numerous projects and build configurations."]},{"i":"hash-files","l":".hash Files","p":["Sometimes, .NET Reactor creates files with the .hash extension. These files are used internally by .NET Reactor to determine whether a file has already been protected. You do not need to ship them with your application; therefore, you can safely ignore them."]},{"l":"Summary","p":["The Build Integration Manager streamlines the process of protecting your assemblies with .NET Reactor by injecting protection steps into your build workflow. By configuring the Solution File, .NET Reactor Project File, Output File, Command-line Parameters, and Protection Timing, you can tailor the protection process to fit various build and deployment scenarios. With the Actions Menu and Filter feature, managing large numbers of projects and configurations becomes efficient and straightforward.","Note: Always ensure you are using a licensed version of .NET Reactor for production builds (or use the -licensed parameter) to avoid accidental demo limitations."]}],[{"l":"License Examiner Tool","p":["The License Examiner allows you to view additional license information from an opened license file. To do so, you must load the correct master key by selecting the .NET Reactor project, which generated the protected assembly and license.","License information can also be read programmatically with the .NET Reactor SDK(shipped with .NET Reactor, see location \"...Eziriz.NET Reactor\\SDK\\License Examination\")]."]}],[{"l":"License Invalidation Tool","p":["If you deploy hardware identification locks, you can use the License Invalidation Tool to enforce invalidation of a license on one machine to allow your licensee to move the installation to another machine.","To enforce invalidation, load your .NET Reactor project, open the License Invalidation Tool, and click \"Create Invalidation Tool.\" This creates an executable that your client runs on the invalidation machine to produce a confirmation key. Return of a valid key confirms you can issue a new license."]}],[{"l":"License Reactivation Tool","p":["Once a license is invalidated you can reactivate the invalidated license using this tool. If you deploy hardware identification locks, you can use the License Invalidation Tool and License Reactivation Tool to enforce invalidation of a license on one machine to allow your licensee to move the installation to another machine.","To reactivate a license, load your .NET Reactor project, open the License Reactivation Tool, enter the Hardware ID of the corresponding machine and click \"Generate Reactivation Code \". Every time you click on \"Generate Reactivation Code\" a new reactivation code is generated. Please note, each reactivation code is only valid for one reactivation! To reactivate a license, please use the method Status.ReactivateLicense(string code) of the library License.dll(part of the SDK)."]}],[{"l":"Stack Trace Deobfuscator","p":["To deobfuscate a stack trace, load the corresponding mapping file, copy and paste the obfuscated stack trace, and click \"Deobfuscate\"."]}],[{"i":"library---test-environment","l":"Library - Test Environment","p":["Library developers will often want to test their project output alternately under unprotected and .NET-Reactor-protected conditions. To alternate your test environment, first, delete the existing reference to your library output in your test project and delete any library components installed in the Toolbox.","• To test the .NET-Reactor-protected version of your library, re-add the reference to your library back into your test application, this time pointing the reference to the .NET-Reactor-protected version of your library (Solution Explorer->References->Add Reference->[.NET-Reactor-protected version of your library]). Install this .NET-Reactor-protected version of your library as well to the Toolbox.","• To test the unprotected version of your library, add the reference to the unprotected version of your library into your test application, and install the (same) unprotected version of your library to the Toolbox.","In each case, the singular reference to your library and the version of your library installed to the Toolbox must be in agreement."]}],[{"l":"Protect An Assembly","p":["Open a new or saved project.","On the Files page, select your assemblies and configure basic protection. Select Library or Application as matches the main assembly you want to protect.","Open Assembly Button","Detail your configuration on the Settings page.","Settings Page","Click Protect on the Tasks Panel.","Protect Button","Protected output is saved to the indicated subdirectory. You may copy this output to a test directory for testing or test from the output directory. In either case, as a usual practice requires, you must copy or move all dependent files to the destination directory for your assembly to function there.","Finalization"]}],[{"l":"Lock An Assembly","p":["Open a new or saved project.","On the Files page, select your assemblies and configure basic protection. Select Library or Application as matches the main assembly you want to protect and lock.","Open Assembly Button","Detail your protection configuration on the Settings page.","Settings Page","Configure Lock Settings","Lock Settings","Click Protect on the Tasks Panel.","Protect Button","Protected output is saved to the indicated subdirectory. You may copy this output to a test directory for testing or test from the output directory. In either case, as a usual practice requires, you must copy or move all dependent files to the destination directory for your assembly to function there.","Finalization","Save your project."]}],[{"l":"Unlock An Locked Assembly","p":["Open your saved project.","Detail your license settings on the License Manager page.","License Manager","Click Create License on the License Manager page.","Save the license file.","Save License Dialog","Copy the license file to the location of the locked assembly. Your locked assembly is unlocked now."]}],[{"l":"Order Online","p":["How to register .NET Reactor Online","Order your .NET Reactor license online at https://www.eziriz.com/order.htm.","Purchased licenses are delivered by email. [Be sure to include eziriz.com in your approved sender's list so that your license will bypass mail filters. ]To complete your registration, click Help->Registration. Open your license file in the dialog, click OK, and restart to validate your .NET Reactor installation."]}],[{"i":"why-register","l":"Why register?","p":["Trial .NET Reactor installations can be downloaded from www.eziriz.com for a free evaluation, but you cannot distribute software processed with unlicensed .NET Reactor installations. You must license your .NET Reactor installation to deploy software protected by .NET Reactor.","Benefits of registration","- The message 'This software is protected by an unregistered version of .NET Reactor' will no longer appear in application or library assemblies processed by .NET Reactor.","- Legal authority to use .NET Reactor for commercial purposes.","- Free technical support by e-mail."]}],[{"l":"Trimming Problems","p":["When protecting .NET projects with .NET Reactor, the injected protection algorithms may reference classes or members. If the project is deployed using the trimming option (e.g., for optimizing application size during publishing), these references might point to removed elements, leading to runtime errors or broken functionality."]},{"l":"Solution","p":["To ensure that the necessary classes and members are preserved during the trimming process, you can use the Eziriz.Reactor.TrimHelper NuGet package and provide additional configuration in your project."]},{"l":"Steps to Resolve","p":["Install the NuGet Package","Add the Eziriz.Reactor.TrimHelper NuGet package to your project. This package ensures the required classes and members used by the protection algorithms are not trimmed.","Alternatively, you can install it via the NuGet Package Manager in your IDE.","NuGet Package Link: Eziriz.Reactor.TrimHelper","Update the project file","Add the following configuration to your project file (.csproj, .vbproj...) file to explicitly preserve all types and members within the TrimHelper assembly:","Read More: Root Assemblies","Alternatively Update the Link XML File","Add the following configuration to your link.xml file:","Read More: Root Descriptors","Below is an example link.xml file with the required entry for TrimHelper:"]},{"l":"Why This is Necessary","p":["The trimming process removes unused code to reduce the application size. However, .NET Reactor's protection algorithms may rely on specific classes or members being available at runtime. Using the Eziriz.Reactor.TrimHelper package and updating project file (or link.xml) ensures these critical elements are preserved.","By following the steps above, you can safely use .NET Reactor with projects that utilize trimming without encountering runtime issues."]}],[{"l":"Trimming Problems","p":["When protecting .NET projects with .NET Reactor, the injected protection algorithms may reference classes or members. If the project is deployed using the trimming option (e.g., for optimizing application size during publishing), these references might point to removed elements, leading to runtime errors or broken functionality."]},{"l":"Solution","p":["To ensure that the necessary classes and members are preserved during the trimming process, you can use the Eziriz.Reactor.TrimHelper NuGet package and provide additional configuration in your project."]},{"l":"Steps to Resolve","p":["Install the NuGet Package","Add the Eziriz.Reactor.TrimHelper NuGet package to your project. This package ensures the required classes and members used by the protection algorithms are not trimmed.","Alternatively, you can install it via the NuGet Package Manager in your IDE.","NuGet Package Link: Eziriz.Reactor.TrimHelper","Update the project file","Add the following configuration to your project file (.csproj, .vbproj...) file to explicitly preserve all types and members within the TrimHelper assembly:","Read More: Root Assemblies","Alternatively Update the Link XML File","Add the following configuration to your link.xml file:","Read More: Root Descriptors","Below is an example link.xml file with the required entry for TrimHelper:"]},{"l":"Why This is Necessary","p":["The trimming process removes unused code to reduce the application size. However, .NET Reactor's protection algorithms may rely on specific classes or members being available at runtime. Using the Eziriz.Reactor.TrimHelper package and updating project file (or link.xml) ensures these critical elements are preserved.","By following the steps above, you can safely use .NET Reactor with projects that utilize trimming without encountering runtime issues."]}],[{"l":"Technical Support","p":["Bug report","Please make sure that you are using the latest version of NET Reactor and that you have carefully read this help file.","If your problem is not addressed by documentation, the following information is required to provide support:","- A complete description of your problem.","- .NET Reactor version (which must be the latest version).","- Operating System version.","- .NET Framework version.","- How the error or condition has occurred, including the sequence of actions leading up to the error condition, error messages...etc.","Occasionally support cases require sample files to reproduce the error condition. Please compress related material into .zip, .rar or .tar archives.","Email Support","Email the Eziriz support team at support@eziriz.com."]}],[{"l":"Contact","p":["Eziriz Home Page","www.eziriz.com","E-mail","support@eziriz.com","Please study this help file sufficiently before sending questions.","For support issues, please see the Technical Support page instead."]}],[{"l":"Command Line Parameters","p":["-admin[1|0]","-antistrong[1|0]","-antitamp[1|0]","-compression[1|0]","-control_flow_obfuscation[1|0]","-dialogbox_interface[file]","-embed[1|0]","-evaluationenable[1|0]","-evaluationmessage[text]","-evaluationtype[trial | runtime]","-exception_handling[1|0]","-exclude_enums[1|0]","-exclude_events[1|0]","-exclude_fields[1|0]","-exclude_methods[1|0]","-exclude_properties[1|0]","-exclude_serializable_types[1|0]","-exclude_types[1|0]","-expirationdate_enable[1|0]","-expirationdate[y/m/d]","-expirationdatemessage[text]","-file[file]","-files[lib/lib]","-flow_level[1/2/3/4/5/6/7/8/9]","-gradcolorbegin[r/g/b]","-gradcolorend[r/g/b]","-icon[file]","-incremental_obfuscation[1|0]","-internalization_filter[text]","-internalization[1|0]","-invalidlicensemessage[text]","-licensed","-licensing_behaviour[1|0]","-logfile[file]","-mapping_file[1|0]","-masterkey[text]","-masterkeyfile[file]","-merge[1|0]","-messagecaption[text]","-mono[1|0]","-nagmessage[text]","-nativeexe[1|0]","-necrobit_comp[1|0]","-necrobit[1|0]","-number_of_instances_enable[1|0]","-number_of_instances[number]","-number_of_uses_enable[1|0]","-number_of_uses[number]","-numberofinstancesmessage[text]","-numberofinstancesscreen[1|0]","-obfuscate_public_types[1|0]","-obfuscation[1|0]","-prejit[1|0]","-project[file]","-pvkfile[file]","-pvkpassword[text]","-q[uiet]","-regularexpressions[text]","-resourcecompression[value]","-resourceencryption[1|0]","-run_another_process[text]","-run_without_licensefile[1|0]","-showenumberofusesscreen[1|0]","-showevaluationperiodscreen[0|1]","-showloadingscreen[1|0]","-shownagscreen[1|0]","-shownotfoundscreen[1|0]","-shutdown_process[1|0]","-snkeypair[file]","-snpassword[text]","-spcfile[file]","-staticlicensefilename[filename]","-stringencryption[1|0]","-suppressildasm[1|0]","-targetfile[file]","-time[number]","-unprintable_characters[1|0]","-v3mode[1|0]","-visualstyles[1|0]","-xdays[number]",".NET Reactor can either display the nag screen every time the application is started (in which case set the value of this option to -1), or a specified number of days before the end of the Evaluation Period or Expiry Date.",".NET Reactor creates a new file containing your protected assembly. This field allows you to specify the path and name of that file. If left blank, .NET Reactor will write the new file to a default location.",".NET Reactor is able to generate a native x86 EXE file stub for your application. This way it is not possible to directly open your protected application in a decompiler. The decompiler recognizes your protected application as a native EXE file.[1] = Enable[0] = Disable",".NET Reactor v3.x uses a new encryption technique which is not backward compatible with previous versions of .NET Reactor. Set this option to True to use .NET Reactor v3 license encryption technique, or False to use the V2.x compatible encryption method.","**-showexpirationdatescreen **[1|0]","1. General Settings","2. Protection Settings","3. Lock Settings","4. Dialog Settings","Anti ILDASM/Suppress Decompilation","Anti Tampering","Application Settings","Arguments","Automatic Exception Handling","Choose a compression method. 'Fastest' offers poor compression but it is very quick. 'MaxCompression' offers best protection but it is the slowest compression method. 'NoCompression' doesn't apply compression at all.[nocompression] = No compression will be applied[fastest] = Offers poor compression but it is very quick[fast][normal] [good][max] = Offers best protection but it is the slowest compression method Example:-resourcecompression good","Choose a day. Your inbuilt license will be valid up to this day. After this day your customer will need a new license file.[year/month/day] for example '2023/1/15'","Choose between Trial and Runtime[trial] = Trial [runtime] = Runtime","Compression","Compression Method","Control Flow Obfuscation","Control Flow Obfuscation Level","Create Mapping File","Define types you want to keep public or make internal. Example:-internalization_filter \"[internal];[public][MyAssembly]MyNamespace.;[internal][MyAssembly]MyNamespace2.MyType\"","Description","Dialog","Dialog Box Interface","Dialog Caption","Digital Certificate","Disable this option to prevent serializable types from obfuscation.[1] = Enable[0] = Disable","Embed assemblies.[1] = Enable[0] = Disable","Embed Assemblies[1] = Enable[0] = Disable","Enable \"Control Flow Obfuscation\" to mangle program flow, making it extremely difficult for humans to follow the program logic. Most decompiler are unable to decompile control flow obfuscated methods.[1] = Enable[0] = Disable","Enable Mapping file to create a file which cross reference unobfuscated names with obfuscated ones, which is used by the Stack Trace Deobfuscator.[1] = Enable[0] = Disable","Enable this option if your assembly targets Mono.[1] = Enable[0] = Disable","Enable this option to compress and encrypt embedded resources.[1] = Enable[0] = Disable","Enable this option to suppress disassembly to IL using the ildasm.exe tool. Even if this option it set to FALSE your source code is still secure![1] = Enable [0] = Disable","Enable this option to use NecroBit protection. NecroBit can be used with both Application and Library protection mode. In Library protection mode an additional file will be created.[1] = Enable[0] = Disable","Enable this to obfuscate all non public class and member names.[1] = Enable [0] = Disable","Enable this to obfuscate all type and member names in an assembly.[1] = Enable[0] = Disable","Enable this to show a message screen when evaluation period is expired.","Enable Visual Styles","Enable/Disable NagScreen[1] = Enable[0] = Disable","Enable/Disable Screen[1] = Enable [0] = Disable","Enable/Disable the LoadingScreen[1] = Enable[0] = Disable","Evaluation period expired message.","Evaluation Type","Exclusions","Exclusions - Enums[1] = Enable[0] = Disable","Exclusions - Events[1] = Enable[0] = Disable","Exclusions - Fields[1] = Enable[0] = Disable","Exclusions - Methods[1] = Enable[0] = Disable","Exclusions - Properties[1] = Enable[0] = Disable","Exclusions - Regular Expressions","Exclusions - Types[1] = Enable[0] = Disable","Expiration Date","Expire When All Expired","Filename of the main assembly.","Filter","Force Admin Privileges","General Arguments","Gradient Color Begin","Gradient Color End","Gradient Color of the message windows.<red/green/blue> for example '212/15/128'","Here you can set the message for the nag screen.","If enabled, .NET Reactor will convert all public types of an application into internal ones. This way the accessibility of types and members is reduced.[1] = Enable[0] = Disable","If set to True(\"1\"), .NET Reactor will compress your .exe file and embedded files saving space on disk and bandwidth if you provide your code for internet download.[1] = Enable [0] = Disable","If you don't want your protected application to catch exceptions automatically, set this option to False(\"0\").[1] = Enable [0] = Disable","If you have problems with reflection on NecroBit protected libraries you should enable this option.[1] = Enable[0] = Disable","If you want .NET Reactor always to generate the same obfuscation strings for your type and member names, you need to enable this option.[1] = Enable[0] = Disable","If you want to use a different icon for an application you need to set the path for the icon here.","If you wish to use visual styles (which are a feature of Windows Xp and Windows Vista), you will need to set this option to True. If set to false, any attempt in your assembly to enable visual styles will be ineffective.[1] = Enable [0] = Disable","If your software requires administrator privileges under Windows Vista/7 you need to set this option to true. In this case a consent dialog is shown in Windows Vista/7.[1] = Enable[0] = Disable","In case .NET Reactor is NOT running as full version no files will be protected and .NET Reactor will return the return/exit code 101.","In combination with the Native EXE File feature and NecroBit, .NET Reactor is able to convert managed methods into REAL x86 native code. Only methods which doesn't affect the runtime and platform behavior (mostly small methods like property getters/setters...) are converted into native code. By nature this feature has an built-in protection against assembly modification.[1] = Enable[0] = Disable","In most cases you don't need to study this page as you can easily create the parameters through the .NET Reactor menu item 'Command-line'>'Generate Command-line'.","Inbuilt Lock - Eveluation Period","Inbuilt Lock - Expiration Date","Inbuilt Lock - Number Of Uses","Incremental Obfuscation","Instances","KeyPair File","KeyPair Password","License Not Found Screen","Main Window","Master Key (used ONLY for Lock settings).","Max Number Of Instances","Merge Assemblies","Merge assemblies.[1] = Enable[0] = Disable","Merge Assemblies[1] = Enable[0] = Disable","merge[1|0]","Message","Nag Screen","Native EXE File","NecroBit Protection","NecroBit/Reflection Compatibility Mode","Obfuscate Public Types","Obfuscation","Opens or launches another application, file, or web site upon expiration. Usually used to send evaluation users to a web page.","Pack Assemblies","Path to a .NET Reactor project file (contains the Master Key as well).","Path to a Master Key file (used ONLY for Lock settings).","PFX/PVK Password","PFX/SPC File Name","Please define additional files here. If '-embed 1' or '-merge 1' is set, the additional files are embedded into your application or they are directly merged with the main assembly. In case neither '-embed 1' nor '-merge 1' is set the Additional Files (*.dll and *.exe files only) are protected separately.[library / library] for example \"C:\\lib1.dll/C:\\lib2.dll/C:\\lib3.dll\"","Pre-JIT Methods","Private Key File Password.","Private Key File.","Public Types Internalization","PVK Filename","Resource Encryption Compression","Run Another Process After Expiration","Run Without License File","Set to false(0) to require a valid license for operation. If true, enabled Inbuilt Locks are honored. If a valid license file is found the Inbuilt Locks settings are overriden with the license file settings.[1] = Enable [0] = Disable","Show Loading Screen","Shutdown Process After Expiration","Software Publisher Certificate File.","Specifies a license file name or extension (*.myextension). Leave blank to allow .NET Reactor to determine a *.license file name from your assembly name. To avoid conflicts with optional methods of extending license behavior, binary .NET Reactor licenses do not use the .LIC extension reserved to .NET license classes.","Specifies quiet mode; suppresses the display of success messages","Specifies whether a dialog box should be displayed to the user when the Expiration Date is reached.","Specifies whether a dialog box should be displayed to the user when they attempt to run more than the specified number of instances of your application.[1] = Enable [0] = Disable","Specifies whether a dialog box should be displayed to the user when your application has been used the specified number of times.[1] = Enable [0] = Disable","Specify the number of days or minutes for the evaluation period.","Specify the number of times the user can run your application before it expires.","Static License FileName","String Encryption","String Encryption disguises internalized text, making it all the more difficult to decipher the interaction of your CIL.[1] = Enable [0] = Disable","Strong Name","Strong Name Key Pair file (.snk/.pfx)","Strong Name Key Pair file password","Strong Name Removal Protection","Target File","Target File should be left blank, unless you want to specify the location of the protected output.","Terminates the running process upon expiration.[1] = Enable [0] = Disable","The Evaluation period lock enables the creation of trial versions of your application, limiting the use of your trial in a variety of ways(Trial or Runtime).[1] = Enable[0] = Disable","The Expiration Date lock allows you to specify the exact date on which your application should expire.[1] = Enable[0] = Disable","The max number of instances lock allows you to specify the maximum number of copies of your application the user is allowed to start at the same time. Please note that exceeding the specified number of instances does NOT cause your application to expire.[1] = Enable[0] = Disable","The maximum number of instances.","The text of the message which is issued when a license file is not found (if \"Run Without License\" is set to false), is found but is corrupt or otherwise invalid.","This is the title of all message forms which can be shown.","This lock, if enabled, causes your application to expire after the specified number of uses.[1] = Enable[0] = Disable","This option enables anti Strong Name removal techniques which prevents your protected assembly from being tampered by hacker tools. Warning, this option can impact the runtime performance of your protected assembly![1] = Enable[0] = Disable","This option enables you to control the level of Control Flow Obfuscation. While \"1\" represents the lowest level of Control Flow Obfuscation, \"9\" represents the strongest level.","This option prevents your protected assembly from being tampered by hacker tools.[1] = Enable[0] = Disable","Time","Unprintable characters uses unprintable strings to obfuscate type and member names, but cannot be used if your assembly must run as safe code.[1] = Enable[0] = Disable","Use Uprintable Characters","Uses","Uses a customizable dialog box you may build with the SDK. Please set the FullName of your Dialog Box here(e.g. MyNamespace.MyDialogBox). Please check the SDK for more information.","V3 Licensing Mode","When set to True(\"1\") causes the expiration of the assembly only when all other enabled locks have expired. When set to False the assembly expires when any one of the locks expires.[1] = Enable [0] = Disable","Writes all important events (successful protection and error messages) into the specified file.","XDays","You can also access the functionality of .NET Reactor through command-line parameters."]},{"i":"example-combinations","l":"Example Combinations:","p":["dotNET_Reactor.Console.exe -file \"c:\\testapp.exe\"","dotNET_Reactor.Console.exe -file \"c:\\testlib.dll\" -licensed","dotNET_Reactor.Console.exe -project \"c:\\projx.nrproj\"","dotNET_Reactor.Console.exe -project \"c:\\projx.nrproj\" -masterkeyfile \"c:\\masterkey.mkey\"","dotNET_Reactor.Console.exe -file \"c:\\testapp.exe\" -project \"c:\\projx.nrproj\"","dotNET_Reactor.Console.exe -file \"c:\\testapp.exe\" -project \"c:\\projx.nrproj\" -q -licensed","dotNET_Reactor.Console.exe -file \"c:\\testapp.exe\" -evaluationenable 1 -evaluationtype trial -time 14","dotNET_Reactor.Console.exe -file \"c:\\testapp.exe\" -showloadingscreen 0"]}],[{"l":"License Agreement","p":["Acknowledgment of External Factors. You acknowledge that certain external factors beyond the control of Eziriz, such as updates or changes to operating systems, runtime environments (e.g., .NET Framework or .NET Core), or third-party dependencies, may affect the compatibility or performance of software protected with this Software Product. Eziriz does not guarantee that the protected software will remain fully compatible with all future updates or changes to these systems.","By installing, copying, or otherwise using the Software Product, you agree to be bound by the terms of this EULA. If you do not agree to any of the terms of this EULA, you are not permitted to use the Software Product in any way, and all copies of it must be deleted from your system(s).","Commercial Use: Works based on the Software Product for general purpose and commercial distribution, or, use of the Software Product (either in whole or in part) whether payment, profit or financial gain is sought directly or indirectly, regardless of whether payment or gain is actually realized.","Company License. If you purchased a Company License you may install this Software Product on an unlimited number of machines within your company. You may duplicate and distribute this product within your company, provided that each copy is a true and complete copy, including all copyright and trademark notices, and includes a copy of this EULA. You are permitted to protect and redistribute any number of non-commercial or commercial software you develop. You may not duplicate or distribute the Software Product outside of your company. Use of the Software Product by individuals not directly employed by your company, including contract developers, is permitted only if each such individual has independently obtained a license to use the Software Product.","Consideration. For the rights and license granted in this EULA you will pay Eziriz the currently published retail price available at eziriz.com or another mutually agreed upon amount to appear on a valid invoice.","COPYRIGHT. All title and copyrights in and to the Software Product (including but not limited to any images, photographs, text, and \"applets\" incorporated into the Software Product), the accompanying printed materials, and any copies of the Software Product are owned by Eziriz. The Software Product is protected by copyright laws and international treaty provisions. Therefore, you must treat the Software Product like any other copyrighted material.","Data Collection and Usage.","DEFINITIONS","Derived Works. You agree that you will not use the Software Product to develop derived works that offer similar functionality as the Software Product, expose the features of the Software Product for use by an unlicensed third party. For a period of six (6) months from the date of purchase, you agree not to create software that might directly compete with Eziriz products at the time of the purchase.","DESCRIPTION OF OTHER RIGHTS AND LIMITATIONS.","Disassembly. You may not modify this product in any manner. You shall not, nor allow others to copy, in whole or in part, emulate, sub-license, sell, transfer, exploit, alter, modify or adapt the Software Product nor decompile, disassemble or reverse engineer the same nor attempt to do such thing.","Disclaimer of Effects on Protected Software. By using the Software Product, you acknowledge and agree that the obfuscation and encryption process applied to your software may alter its structure and behavior in ways that could lead to unexpected or unpredictable runtime behavior. This includes, but is not limited to, compatibility issues with specific environments, frameworks, or future updates to operating systems, runtime environments, or dependent libraries. You agree that it is your responsibility to thoroughly test the protected software in all intended deployment environments and to ensure its continued functionality after updates to such systems.","DISCLAIMER. THIS SOFTWARE IS PROVIDED \"AS IS\", WITHOUT A WARRANTY OF ANY KIND. THE AUTHOR OF THIS SOFTWARE (\"EZIRIZ\") DON'T TAKE ANY RESPONSE FOR ANY DAMAGES SUFFERED AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THE SOFTWARE. IN NO EVENT WILL EZIRIZ BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE SOFTWARE, EVEN IF EZIRIZ HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. THE AUTHOR DOES NOT WARRANT THAT EZIRIZ .NET Reactor IS FREE FROM BUGS, ERRORS, OR OTHER PROGRAM LIMITATIONS. LIMITATION OF LIABILITY AND DAMAGES TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, THE AUTHOR IS NOT LIABLE FOR ANY INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO: DAMAGES FOR LOSS OF BUSINESS, LOSS OF PROFITS OR INVESTMENT, OR THE LIKE), WHETHER BASED ON BREACH OF CONTRACT, BREACH OF WARRANTY, TORT (INCLUDING NEGLIGENCE), PRODUCT LIABILITY OR OTHERWISE, EVEN IF THE AUTHOR HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES, AND EVEN IF A REMEDY SET FORTH HEREIN IS FOUND TO HAVE FAILED OF ITS ESSENTIAL PURPOSE. THE AUTHOR WILL NOT BE SUBJECT TO LIABILITY FOR ANY BUGS OR DAMAGES CAUSED BY CERTAIN .NET Reactor FEATURES.","END-USER LICENSE AGREEMENT (EULA)","Entire Agreement. This EULA constitutes the entire agreement between the parties regarding the Software Product and supersedes all prior agreements.","Eziriz is not obligated to provide support for works derived from the Software Product.","Eziriz is not obligated to, but may at its own option, provide free email support.","Eziriz periodically releases updates to existing versions and completes new versions of the Software Product. For a period of one year following the purchase of the Software Product, updates and new versions are free of cost.","FINAL PROVISIONS","General Software License Grant. You are granted a right to install the Software Product and use it to process your own software with the Software Product. Eziriz grants the use of the Software Product according to one of the license types below as identified in the product title. Licenses purchased for development do not extend to third parties, even if the software was developed for that third party. All entities must have a separate license.","GOVERNING LAW AND DISPUTES. This EULA shall be governed by the laws of Germany. Any disputes shall be resolved exclusively in German courts. The End User waives their right to participate in any collective or class-action lawsuits against Eziriz.","GRANT OF LICENSE. Eziriz grants you the rights described in this EULA provided that you comply with all the terms and conditions of this EULA:","If this copy of the Software Product is an upgrade from an earlier version of the Software Product, it is provided to you on a license exchange basis. You agree by your installation and use of such copy of the Software Product to voluntarily terminate your earlier EULA and that you will not continue to use the earlier version of the Software Product or transfer it to another person or entity unless such transfer is otherwise valid according to the terms of this EULA.","Important - Read carefully:","INDEMNIFICATION. The End User agrees to indemnify and hold harmless Eziriz against any claims, damages, or liabilities arising from:","Language of Agreement. You agree that this EULA be drafted in the English language.","Legal actions resulting from the deployment or distribution of protected software.","LIMITATION OF LIABILITY.","MARKETING. You agree to be identified as a customer of Eziriz and that Eziriz may refer to you by name, trade name and trademark, if applicable, and may briefly describe your business in Eziriz's marketing materials, on Eziriz's website, in public or legal documents. You hereby grant Eziriz a license to use your name and any of your trade names and trademarks solely pursuant to this marketing section.","No additional personal data is collected, stored, or transmitted by the Software Product during its operation.","No liability for damages. To the maximum extent permitted by applicable law, in no event Eziriz is liable for damages, including any general, special, incidental or consequential damages arising out of the use or inability to use this product (including but not limited to loss of data, or data being rendered inaccurate, or losses sustained by you or third parties, or a failure of the program to operate with any other programs), even if Eziriz has been advised of the possibility of such damages.","No warranties. Eziriz expressly disclaims any warranty for the Software Product. The Software Product and any related documentation is provided \"as is\" without warranty of any kind, either express or implied, including, without limitation, the implied warranties or merchantability, fitness for a particular purpose, or non-infringement. The entire risk arising out of use or performance of the Software Product remains with you.","PRIVACY AND DATA PROTECTION.","Privacy Policy. Detailed information about the collection, processing, and storage of customer data, including rights under GDPR, can be found in our Privacy Policy: https://www.eziriz.com/privacypolicy.htm","Proprietary notices. You may not remove any proprietary notices or labels on the Software Product.","Redistribution.","Rental. You may not lease or rent the Software Product.","Reservation of Rights. Eziriz reserves all rights not expressly granted herein.","Severability. If any provision of this EULA is found invalid or unenforceable, the remaining provisions shall remain in full force and effect.","Single Developer License. If you purchased a Single Developer License, Eziriz grants to you one (1) personal, nontransferable, nonexclusive, royalty-free license to use copies of the Software Product and install such Software on your machine(s) for your single concurrent internal use, to use and redistribute any number of non-commercial or commercial software you develop. Use of the Software Product by other individuals is permitted only if said other individual has been licensed to use the Software Product.","SOFTWARE MAINTENANCE AND UPDATES","Term. The term of this EULA shall continue perpetually from the date of purchase unless terminated according to the provisions in section 2(d).","Termination. Without prejudice to any other rights, Eziriz may terminate this EULA if you fail to comply with the terms and conditions of this EULA. In such an event, you must destroy all copies of the Software Product and all of its component parts.","TERMS AND CONDITIONS","The Software Product is protected by copyright laws and international copyright treaties, as well as other intellectual property laws and treaties. The Software Product is licensed, not sold.","The Software Product processes only the personal data provided in the license file. This information is partially displayed in the title bar and in the \"About\" window of the Software Product.","The use or misuse of the Software Product.","This End-User License Agreement (\"EULA\") is a legal agreement between you (either an individual or a single entity) and the author of this Software (\"Eziriz\") for the Software Product \".NET Reactor\", which includes computer software and may include associated media, printed materials, and \"online\" or electronic documentation (\"Software Product\"). The Software Product also includes any updates and supplements to original software provided to you.","To receive program updates after the first year it is necessary to pay an annual renewable maintenance (visit https://www.eziriz.com/renewal.htm for the latest posted price). By paying the annual maintenance fee the license holder is entitled to receive all program updates for another year.","Trial/Demo version (No costs). Use of the Software Product without purchasing a License shall be limited to evaluation purposes only. Programs created using a trial license must be destroyed when the trial period has expired. Software protected using a trial license cannot be bought, sold, licensed, copied, traded or otherwise used by other individuals.","When purchasing the Software Product, customer data such as name, email address, and payment information may be collected and processed for order fulfillment, license generation, and payment processing.","You are granted a royalty-free license to redistribute in binary form any components of the Software Product explicitly marked as redistributable provided that you provide all technical support for the distribution, you do not allow recipients to disassemble, decompile, or in any other way allowing them to gain separate access to the Software Product or any part of the Software Product."]}]];